/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;namespace PluginIdea.ContexMenuSystem{    public class CallbackData    {        public string text;        public OptBase opt;        public ContextMenu subContex;        public GameObject buttonObject;    }    public class CoreModule : CMModuleBase    {        private Canvas popupCanvas;        private CommandClass commandClass;        private Dictionary<string, CallbackData> dic_callbacks = new Dictionary<string, CallbackData>();        private GameObject buttonTemplate;        private float rbmHoldTime;        public CoreModule(ContexMenuSystem ower)        {            this.ower = ower;        }        public override void Init()        {            Utils.SetupInfoText(ower, "<size=40><b>Contex Menu: </b></size>" +                "leftCtrl + MouseRight to Open ContexMenu", 100, true);            popupCanvas = Utils.AppendCanvasObjectUnderHeadCenter("ContexViewSpaceCanvas", true);            var canvasObj = popupCanvas.gameObject;        }        public override void OnReApplyUIParameter()        {            commandClass = new CommandClass(ower.ContexMenuUIObject, popupCanvas.transform);        }        public override void OnUpdate()        {            if (Input.GetMouseButtonDown(1))            {                rbmHoldTime = 0;            }            rbmHoldTime += Time.deltaTime;                        if (Input.GetMouseButtonUp(1) && rbmHoldTime < 0.2f)            {                                if (Input.GetKey(KeyCode.LeftAlt))                {                    bool isUICast = ower.GetUIRaycastList();                    bool isHitObject = ower.GetRaycastObject();                    if (!isUICast && !isHitObject) return;                    CheckInfo checkInfo;                    if (CommandCheck.CheckRightClick(ower.RaycastHit, ower.CastList, out checkInfo))                    {                        commandClass.CreateMenuTree(checkInfo);                    }                }                                else                {                    commandClass.CreateMenuTree(new CheckInfo() { code = CommandType.CommonMenu });                }                                              ower.TimerManager.AddTimer(.1f, () => {                    commandClass.ShowAtMousePosition();                });            }        }        public override void UnInit()        {            if (popupCanvas != null)            {                dic_callbacks.Clear();                GameObject.Destroy(popupCanvas.gameObject);            }        }    }}